require 'rubygems'
require 'yaml'
require "optparse"
require 'ostruct'
require 'pg'
require 'active_record'
require 'composite_primary_keys'

require_relative 'by2/version'
require_relative 'by2/options'
require_relative 'by2/config_loader'
require_relative 'by2/utils'
require_relative 'by2/ext/active_record'
require_relative 'by2/models'
require_relative 'by2/client'


module By2
  def self.root
    @root ||= File.expand_path(File.join(__FILE__, '..', '..'))
  end

  def self.config
    @config ||= ConfigLoader.new
  end

  def self.fixtures_dir
    File.join(root, "spec", "fixtures")
  end

  def self.db_connect
    @conn ||= begin
      conn_config = config.load("database.yml")
      #ActiveSupport::Deprecation.silenced = true
      ActiveRecord::Base.default_timezone = :local
      ActiveRecord::Base.establish_connection(conn_config[env])
      ActiveRecord::Base.connection
      ActiveRecord::Base.logger = Logger.new(STDOUT) if debug?
    end
  end

  def self.env
    @env ||= (ENV['BY2_ENV'] || config.load("env.yml", false) || "development")
  end

  def self.debug?
    @debug ||= false
  end

  def self.debug=(d)
    @debug = d
  end

  def self.debug(msg)
    $stdout.puts(msg) if debug?
  end
end


By2.db_connect

=begin
require "./lib/by2"
By2.db_connect
cli = By2::Client.new([])
ip = By2::Utils.int32_to_ip(2154959208)

q = cli.find_entries({ip: ip});
=end