module By2
  class ConfigLoader
    attr_accessor :search_paths

    def initialize
      @search_paths ||= [app_config, user_config]
    end

    def load(config_file, required = false)
      search_paths.each do |path|
        file = File.expand_path(File.join(path, config_file))
        By2.debug("Searching for #{file} in #{path}")

        if File.exists?(file)
          By2.debug("Loaded: #{file}")
          return YAML.load_file(file)
        end
      end

      By2.debug("Could not load: #{config_file}")
      required ? raise : nil
    end

    private

    def app_config
      @app_config ||= File.expand_path(File.join(::By2.root, "config"))
    end

    def user_config
      @user_config ||= File.expand_path(File.join(ENV['HOME'], ".by2"))
    end
  end
end