module By2
  module Models

    class Iphdr < ActiveRecord::Base
      self.table_name = 'iphdr'
      self.primary_keys = :sid, :cid

      belongs_to :event, :foreign_key => [:sid, :cid]


      def self.ip_src_or_dst(ip)
        where("iphdr.ip_dst = ? or iphdr.ip_src = ?",  int32(ip),  int32(ip))
      end

      def self.ip_src(ip)
        where("iphdr.ip_src = ?", int32(ip))
      end

      def self.ip_dst(ip)
        where("iphdr.ip_dst = ?", int32(ip))
      end

      def ipaddr_src
        Utils.int32_to_ip(self.ip_src)
      end

      def ipaddr_dst
        Utils.int32_to_ip(self.ip_dst)
      end

      private

      def self.int32(ip)
        Utils.ip_to_int32(ip)
      end
    end
  end
end