module By2
  module Models
    class Tcphdr < ActiveRecord::Base
      self.table_name = 'tcphdr'
      self.primary_keys = :sid, :cid

      belongs_to :event, :foreign_key => [:sid, :cid]

      def self.src_or_dst_port(port)
        where("tcphdr.tcp_sport = ? or tcphdr.tcp_dport = ?",  port, port)
      end

      def self.src_port(port)
        where("tcphdr.tcp_sport = ?",  port)
      end

      def self.dst_port(port)
        where("tcphdr.tcp_dport = ?",  port)
      end

      def dport
        tcp_dport
      end

      def sport
        tcp_sport
      end
    end
  end
end