module By2
  module Models
    class Udphdr < ActiveRecord::Base
      self.table_name = 'udphdr'
      self.primary_keys = :sid, :cid

      belongs_to :event, :foreign_key => [:sid, :cid]

      def self.src_or_dst_port(port)
        where("udphdr.udp_sport = ? or udphdr.udp_dport = ?",  port, port)
      end

      def self.src_port(port)
        where("udphdr.udp_sport = ?",  port)
      end

      def self.dst_port(port)
        where("udphdr.udp_dport = ?",  port)
      end

      def dport
        udp_dport
      end

      def sport
        udp_sport
      end
    end
  end
end